/*
	Log.js
	author: masatoshi teruya
	email: mah0x211@gmail.com
	copyright (C) 2011, masatoshi teruya. all rights reserved.
*/
var package = {
		fs: require('fs'),
		path: require('path')
	},
	Kahana = require( __dirname + '/Kahana' );

Kahana.Inherits( Logger, Kahana );
function Logger()
{
	this.files = {};
}

Logger.prototype.Open = function( label, path )
{
	if( !this.files[label] )
	{
		this.files[label] = {};
		this.files[label].path = package.fs.realpathSync( path );
		this.files[label].fd = package.fs.openSync( this.files[label].path, 'a' );
	}
	
	return label;
};

Logger.prototype.Close = function()
{
	var len = arguments.length;
	
	for( var i = 0; i < len; i++ )
	{
		if( this.files[arguments[i]] ){
			package.fs.close( this.files[arguments[i]].fd );
		}
	}
};

module.exports = Logger;
